'''
Key code
'''
LE_REMOTE_KEY_0 = 0x0000
LE_REMOTE_KEY_1 = 0x0001
LE_REMOTE_KEY_2 = 0x0002
LE_REMOTE_KEY_3 = 0x0003
LE_REMOTE_KEY_4 = 0x0004
LE_REMOTE_KEY_5 = 0x0005
LE_REMOTE_KEY_6 = 0x0006
LE_REMOTE_KEY_7 = 0x0007
LE_REMOTE_KEY_8 = 0x0008
LE_REMOTE_KEY_9 = 0x0009
LE_REMOTE_KEY_A = 0x000a
LE_REMOTE_KEY_B = 0x000b
LE_REMOTE_KEY_C = 0x000c
LE_REMOTE_KEY_D = 0x000d
LE_REMOTE_KEY_E = 0x000e
LE_REMOTE_KEY_F = 0x000f
LE_REMOTE_KEY_LEFT = 0x0010
LE_REMOTE_KEY_RIGHT = 0x0011
LE_REMOTE_KEY_UP = 0x0012
LE_REMOTE_KEY_DOWN = 0x0013
LE_REMOTE_KEY_ENTER = 0x0014
LE_REMOTE_KEY_PAGEUP = 0x0015
LE_REMOTE_KEY_PAGEDOWN = 0x0016
LE_REMOTE_KEY_MENU = 0x0017
LE_REMOTE_KEY_DISPLAY = 0x0018
LE_REMOTE_KEY_TIMECOUNT = 0x0019
LE_REMOTE_KEY_HEXCODE = 0x001a
LE_REMOTE_KEY_DATACODE = 0x001b
LE_REMOTE_KEY_ZOOM = 0x001b
LE_REMOTE_KEY_DELETE = 0x001c
LE_REMOTE_KEY_TOP = 0x001c
LE_REMOTE_KEY_DONTCARE = 0x001d
LE_REMOTE_KEY_BOTTOM = 0x001d
LE_REMOTE_KEY_LOADSAVE = 0x001e
LE_REMOTE_KEY_FIND = 0x001f
LE_REMOTE_KEY_PRINT = 0x0020
LE_REMOTE_KEY_RUN = 0x0021
LE_REMOTE_KEY_STOP = 0x0022
LE_REMOTE_KEY_SHIFTON = 0x0023
LE_REMOTE_KEY_ESC = 0x0024
LE_REMOTE_KEY_POWER = 0x0030
LE_REMOTE_KEY_F1 = 0x0031
LE_REMOTE_KEY_F2 = 0x0032
LE_REMOTE_KEY_F3 = 0x0033
LE_REMOTE_KEY_F4 = 0x0034
LE_REMOTE_KEY_F5 = 0x0035

LE_REMOTE_KEY_SHIFT = 0x0080

'''
Setup
'''
# LE_LPROTOCOL
LE_LPROTOCOL_UNKNOWN = -1
LE_LPROTOCOL_ASYNC = 0
LE_LPROTOCOL_SYNC = 1
LE_LPROTOCOL_HDLC = 2
LE_LPROTOCOL_PPP = 3
LE_LPROTOCOL_IRDA = 4
LE_LPROTOCOL_I2C = 5
LE_LPROTOCOL_BURST = 6
LE_LPROTOCOL_SPI = 10
LE_LPROTOCOL_MODBUS = 15
LE_LPROTOCOL_PROFIBUS = 17

# LE_BUFSIMDATA
LE_BUFSIMDATA_BUF1S = 0
LE_BUFSIMDATA_BUF1R = 1
LE_BUFSIMDATA_BUF2S = 2
LE_BUFSIMDATA_BUF2R = 3

# LE_PROGRAM
LE_PROGRAM_A = 0
LE_PROGRAM_B = 1
LE_PROGRAM_C = 2
LE_PROGRAM_D = 3
NOF_LE_PROGRAM = 4

# LE_STDTABLENO
LE_STDTABLENO_0 = 0
LE_STDTABLENO_1 = 1
LE_STDTABLENO_2 = 2
LE_STDTABLENO_3 = 3
LE_STDTABLENO_4 = 4
LE_STDTABLENO_5 = 5
LE_STDTABLENO_6 = 6
LE_STDTABLENO_7 = 7
LE_STDTABLENO_8 = 8
LE_STDTABLENO_9 = 9
LE_STDTABLENO_A = 10
LE_STDTABLENO_B = 11
LE_STDTABLENO_C = 12
LE_STDTABLENO_D = 13
LE_STDTABLENO_E = 14
LE_STDTABLENO_F = 15
LE_STDTABLENO_ENQ = 16
LE_STDTABLENO_ACK = 17
LE_STDTABLENO_NAK = 18
LE_STDTABLENO_WACK = 19
LE_STDTABLENO_EOT = 20
LE_STDTABLENO_ACK0 = 21
LE_STDTABLENO_ACK1 = 22
LE_STDTABLENO_RVI = 23
LE_STDTABLENO_TTD = 24
LE_STDTABLENO_FOX = 25
LE_STDTABLENO_MSG1 = 26
LE_STDTABLENO_MSG2 = 27
LE_STDTABLENO_DC1 = 28
LE_STDTABLENO_DC3 = 29
LE_STDTABLENO_NULL = -1
NOF_LE_STDTABLENO_USER = 16
NOF_LE_STDTABLENO_ALL = 30

# LE_FLOWWATCH
LE_FLOWWATCH_CS = 0
LE_FLOWWATCH_CD = 1

# LE_FLOWOPERATE
LE_FLOWOPERATE_RS = 0
LE_FLOWOPERATE_ER = 1

# LE_LOOPBACKLINE
LE_LOOPBACKLINE_ERDR = 0
LE_LOOPBACKLINE_ERCD = 1

# LE_BERTPATTERN
LE_BERTPATTERN_63 = 0
LE_BERTPATTERN_511 = 1
LE_BERTPATTERN_2047 = 2
LE_BERTPATTERN_MARK = 3
LE_BERTPATTERN_SPACE = 4
LE_BERTPATTERN_ALT = 5
LE_BERTPATTERN_DBLALT = 6
LE_BERTPATTERN_3IN24 = 7
LE_BERTPATTERN_1IN16 = 8
LE_BERTPATTERN_1IN8 = 9
LE_BERTPATTERN_1IN4 = 10
LE_BERTPATTERN_PN15 = 11
LE_BERTPATTERN_PN20 = 12
LE_BERTPATTERN_PN23 = 13

# LE_BERTCOUNT
LE_BERTCOUNT_1E3 = 0
LE_BERTCOUNT_1E4 = 1
LE_BERTCOUNT_1E5 = 2
LE_BERTCOUNT_1E6 = 3
LE_BERTCOUNT_1E7 = 4
LE_BERTCOUNT_1E8 = 5
LE_BERTCOUNT_1E9 = 6

# LE_BERTMODEEX
LE_BERTMODEEX_CONTINUE = 0
LE_BERTMODEEX_RBIT = 1
LE_BERTMODEEX_RUNTIME = 2
LE_BERTMODEEX_REPEAT = 3
NOF_LE_BERTMODEEX = 4


# LE_DATACODE
LE_DATACODE_ASCII = 0
LE_DATACODE_EBCDIC = 1
LE_DATACODE_EBCDIK = 2
LE_DATACODE_JIS7 = 3
LE_DATACODE_JIS8 = 4
LE_DATACODE_HEX = 5
LE_DATACODE_EBCD = 6
LE_DATACODE_TRANSCODE = 7
LE_DATACODE_IPARS = 8
LE_DATACODE_BAUDOT = 9
NOF_LE_DATACODE = 10

# LE_DATABIT
LE_DATABIT_5 = 0
LE_DATABIT_6 = 1
LE_DATABIT_7 = 2
LE_DATABIT_8 = 3

# LE_PARITY
LE_PARITY_NONE = 0
LE_PARITY_ODD = 1
LE_PARITY_EVEN = 2
LE_PARITY_MARK = 3
LE_PARITY_SPACE = 4
LE_PARITY_MP = 5

# LE_STOPBIT
LE_STOPBIT_1 = 0
LE_STOPBIT_2 = 1

# LE_BCC
LE_BCC_NONE = 0
LE_BCC_LRC_ODD = 1
LE_BCC_LRC_EVEN = 2
LE_BCC_CRC_16 = 3
LE_BCC_CRC_ITUT = 4
LE_BCC_CRC_6 = 5
LE_BCC_CRC_12 = 6

# LE_DATASEQUENCE
LE_DATASEQUENCE_LSBFIRST = 0
LE_DATASEQUENCE_MSBFIRST = 1

# LE_DATAFORMAT
LE_DATAFORMAT_NRZ = 0
LE_DATAFORMAT_NRZI = 1
LE_DATAFORMAT_FM0 = 2
LE_DATAFORMAT_FM1 = 3
LE_DATAFORMAT_MANCHESTER0 = 4
LE_DATAFORMAT_MANCHESTER1 = 5

# LE_CLOCK
LE_CLOCK_ST1 = 0
LE_CLOCK_ST2 = 1
LE_CLOCK_RT = 2
LE_CLOCK_AR = 3

# LE_FCS
LE_FCS_NONE = 0
LE_FCS_16 = 1
LE_FCS_32 = 2

# LE_HDLCIDLEMODE
LE_HDLCIDLEMODE_MARK = 0
LE_HDLCIDLEMODE_FLAG = 1

# LE_HDLCFRAME
LE_HDLCFRAME_NONE = -1
LE_HDLCFRAME_SDLC = 0
LE_HDLCFRAME_SDLCX = 1
LE_HDLCFRAME_X25 = 2
LE_HDLCFRAME_X25X = 3
LE_HDLCFRAME_LAPD = 4

# LE_HDLCPACKET
LE_HDLCPACKET_NONE = -1
LE_HDLCPACKET_X25 = 0
LE_HDLCPACKET_LAPD = 1

# LE_I2CSIMMODE
LE_I2CSIMMODE_SLAVE = 0
LE_I2CSIMMODE_MASTER = 1

# LE_SPISIMMODE
LE_SPISIMMODE_SLAVE = 0
LE_SPISIMMODE_MASTER = 1

# LE_SPICPOL
LE_SPICPOL_0 = 0
LE_SPICPOL_1 = 1

# LE_SPICPHA
LE_SPICPHA_0 = 0
LE_SPICPHA_1 = 1

# LE_MODBUSTRANSM
LE_MODBUSTRANSM_RTU = 0
LE_MODBUSTRANSM_ASCII = 1

# LE_IFPORT
LE_IFPORT_MAIN = 0
LE_IFPORT_SUB = 1

# LE_IFMODE
LE_IFMODE_DTE = 0
LE_IFMODE_DCE = 1

# LE_IFPOLARITY
LE_IFPOLARITY_NORMAL = 0
LE_IFPOLARITY_INVERT = 1

# LE_IFDRVCTRL
LE_IFDRVCTRL_OFF = 0
LE_IFDRVCTRL_MANUAL = 1
LE_IFDRVCTRL_AUTO = 2

# LE_CAPTUREBUF
LE_CAPTUREBUF_0 = 0
LE_CAPTUREBUF_1 = 1
LE_CAPTUREBUF_2 = 2

# LE_IDLETIMEREC
LE_IDLETIMEREC_OFF = 0
LE_IDLETIMEREC_100MS = 1
LE_IDLETIMEREC_10MS = 2
LE_IDLETIMEREC_1MS = 3

# LE_TIMESTAMPREC
LE_TIMESTAMPREC_OFF = 0
LE_TIMESTAMPREC_DHM = 1
LE_TIMESTAMPREC_HMS = 2
LE_TIMESTAMPREC_MS10MS = 3
LE_TIMESTAMPREC_100US = 4
LE_TIMESTAMPREC_10US = 5
LE_TIMESTAMPREC_1US = 6
LE_EXTIMESTAMPREC_YMDHM = 0x21
LE_EXTIMESTAMPREC_MDHMS = 0x22
LE_EXTIMESTAMPREC_DHMS10MS = 0x23

# LE_IFLEVELEX
LE_IFLEVELEX_5V0 = 0
LE_IFLEVELEX_3V3 = 1
LE_IFLEVELEX_2V5 = 2
LE_IFLEVELEX_1V8 = 3

# LE_IFOUTTYPE
LE_IFOUTTYPE_PU = 0
LE_IFOUTTYPE_NOPU = 1
LE_IFOUTTYPE_CMOS = 2


LE_LTABLE_FLAG_BCC_FCS = 0x01
LE_LTABLE_FLAG_PARITY_MP = 0x02

# LE_TRGFACTOR
LE_TRGFACTOR_ERROR = 0
LE_TRGFACTOR_CHARACTER = 1
LE_TRGFACTOR_LINE = 2
LE_TRGFACTOR_TMCT = 3
LE_TRGFACTOR_IDLE = 4
LE_TRGFACTOR_EXTERNAL = 5
NOF_LE_TRGFACTOR = 6

# LE_TRGERROR;
LE_TRGERRORBIT_PARITY = 0
LE_TRGERRORBIT_FRAMING = 1
LE_TRGERRORBIT_BCC = 2
LE_TRGERRORBIT_BRK_ABT = 3
LE_TRGERRORBIT_SHORTF = 4

LE_TRGERROR_NULL = 0x00
LE_TRGERROR_PARITY = 1 << LE_TRGERRORBIT_PARITY
LE_TRGERROR_FRAMING = 1 << LE_TRGERRORBIT_FRAMING
LE_TRGERROR_BCC = 1 << LE_TRGERRORBIT_BCC
LE_TRGERROR_BRK_ABT = 1 << LE_TRGERRORBIT_BRK_ABT
LE_TRGERROR_SHORTF = 1 << LE_TRGERRORBIT_SHORTF
LE_TRGERROR_ALL = LE_TRGERROR_PARITY | LE_TRGERROR_FRAMING | LE_TRGERROR_BCC | LE_TRGERROR_BRK_ABT | LE_TRGERROR_SHORTF

# LE_TRGEDGE
LE_TRGEDGE_RISING = 0
LE_TRGEDGE_FALLING = 1

# LE_TIMERCOUNTER
LE_TIMERCOUNTER_TIMER0 = 0
LE_TIMERCOUNTER_TIMER1 = 1
LE_TIMERCOUNTER_COUNTER0 = 2
LE_TIMERCOUNTER_COUNTER1 = 3
LE_TIMERCOUNTER_TIMER2 = 4
LE_TIMERCOUNTER_TIMER3 = 5
LE_TIMERCOUNTER_COUNTER2 = 6
LE_TIMERCOUNTER_COUNTER3 = 7

# LE_TRGACTION
LE_TRGACTION_BUZZER = 0
LE_TRGACTION_STOP = 1
LE_TRGACTION_SAVE = 2
LE_TRGACTION_TIMER = 3
LE_TRGACTION_COUNTER = 4
LE_TRGACTION_TRIGSW = 5
LE_TRGACTION_SEND = 6
LE_TRGACTION_TRGOUT = 7
LE_TRGACTION_LEDOUT = 8

# LE_TRGSTOP
LE_TRGSTOP_QUICK = 0
LE_TRGSTOP_BEFORE = 1
LE_TRGSTOP_CENTER = 2
LE_TRGSTOP_AFTER = 3

# LE_TRGTIMERACTION
LE_TRGTIMERACTION_START = 0
LE_TRGTIMERACTION_STOP = 1
LE_TRGTIMERACTION_RESTART = 2

# LE_TRGCOUNTERACTION
LE_TRGCOUNTERACTION_INCREMENT = 0
LE_TRGCOUNTERACTION_CLEAR = 1

# LE_TRGSW
LE_TRGSW_DISABLE = 0
LE_TRGSW_ENABLE = 1
LE_TRGSW_CHANGE = 2

# LE_TRGLED
LE_TRGLED_1 = 0
LE_TRGLED_2 = 1

# LE_TRGLEDACT
LE_TRGLEDACT_OFF = 0
LE_TRGLEDACT_ON = 1
LE_TRGLEDACT_CHANGE = 2

# LE_TIMER
LE_TIMER_0 = 0
LE_TIMER_1 = 1
LE_TIMER_2 = 2
LE_TIMER_3 = 3
NOF_LE_TIMER = 4

# LE_COUNTER
LE_COUNTER_0 = 0
LE_COUNTER_1 = 1
LE_COUNTER_2 = 2
LE_COUNTER_3 = 3
NOF_LE_COUNTER = 4

# LE_TRIGGER
LE_TRIGGER_0 = 0
LE_TRIGGER_1 = 1
LE_TRIGGER_2 = 2
LE_TRIGGER_3 = 3
LE_TRIGGER_4 = 4
LE_TRIGGER_5 = 5
LE_TRIGGER_6 = 6
LE_TRIGGER_7 = 7
NOF_LE_TRIGGER = 8

STATE_RUN = 0x00000100
STATE_BERT = 0x00000800
STATE_BERTSYNC = 0x00001000

'''
Monitor data
'''
LE_MONDATA_FORMAT_1 = 1
LE_MONDATA_FORMAT_2 = 2

LE_MONSTATUS_DATA_VISIBLE = 0x80

LE_MONSTATUS_SD_DATA_VISIBLE = 0x80
LE_MONSTATUS_RD_DATA_VISIBLE = 0x40
LE_MONSTATUS_SD_TIMESTAMP = 0x01
LE_MONSTATUS_RD_TIMESTAMP = 0x02
LE_MONSTATUS_IDLETIME = 0x03
LE_MONSTATUS_CHANGE_CONTROLLINE = 0x04

LE_MONSTATUS_DATASTATUS_SD_PARITY = 0x01
LE_MONSTATUS_DATASTATUS_RD_PARITY = 0x02

LE_CONTROLLINE_RS = 0x01
LE_CONTROLLINE_CS = 0x02
LE_CONTROLLINE_DR = 0x04
LE_CONTROLLINE_CD = 0x08
LE_CONTROLLINE_ER = 0x10
LE_CONTROLLINE_SQ = 0x20
LE_CONTROLLINE_CI = 0x40
LE_CONTROLLINE_EX = 0x80

LE_PROGRESS_SDCOUNTER = 0x00000001
LE_PROGRESS_RDCOUNTER = 0x00000002
LE_PROGRESS_TIMER0 = 0x00000010
LE_PROGRESS_TIMER1 = 0x00000011
LE_PROGRESS_TIMER2 = 0x00000012
LE_PROGRESS_TIMER3 = 0x00000013
LE_PROGRESS_TIMERSET0 = 0x00000018
LE_PROGRESS_TIMERSET1 = 0x00000019
LE_PROGRESS_TIMERSET2 = 0x0000001a
LE_PROGRESS_TIMERSET3 = 0x0000001b
LE_PROGRESS_COUNTER0 = 0x00000020
LE_PROGRESS_COUNTER1 = 0x00000021
LE_PROGRESS_COUNTER2 = 0x00000022
LE_PROGRESS_COUNTER3 = 0x00000023
LE_PROGRESS_COUNTERSET0 = 0x00000028
LE_PROGRESS_COUNTERSET1 = 0x00000029
LE_PROGRESS_COUNTERSET2 = 0x0000002a
LE_PROGRESS_COUNTERSET3 = 0x0000002b
LE_PROGRESS_REGISTER0 = 0x00000030
LE_PROGRESS_REGISTER1 = 0x00000031
LE_PROGRESS_REGISTER2 = 0x00000032
LE_PROGRESS_REGISTER3 = 0x00000033
LE_PROGRESS_REGISTER4 = 0x00000034
LE_PROGRESS_REGISTER5 = 0x00000035
LE_PROGRESS_REGISTER6 = 0x00000036
LE_PROGRESS_REGISTER7 = 0x00000037
LE_PROGRESS_REGISTER8 = 0x00000038
LE_PROGRESS_REGISTER9 = 0x00000039
LE_PROGRESS_REGISTERA = 0x0000003a
LE_PROGRESS_REGISTERB = 0x0000003b
LE_PROGRESS_REGISTERC = 0x0000003c
LE_PROGRESS_REGISTERD = 0x0000003d
LE_PROGRESS_REGISTERE = 0x0000003e
LE_PROGRESS_REGISTERF = 0x0000003f
